package exnihilocreatio.client.renderers;

import exnihilocreatio.blocks.BlockSieve;
import exnihilocreatio.tiles.TileSieve;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.*;
import net.minecraft.client.renderer.block.model.BakedQuad;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import org.lwjgl.opengl.GL11;

import java.util.List;

public class RenderSieve extends TileEntitySpecialRenderer<TileSieve> {


    @Override
    public void func_192841_a(TileSieve te, double x, double y, double z, float partialTicks, int destroyStage, float alpha) {
        Tessellator tes = Tessellator.func_178181_a();

        BufferBuilder wr = tes.func_178180_c();

        float offsetX = 0;
        float offsetY = 0;
        float offsetZ = 0;
        if (te.autoSifter != null && te.autoSifter.toSift != null) {
            offsetX = te.autoSifter.offsetX;
            offsetY = te.autoSifter.offsetY;
            offsetZ = te.autoSifter.offsetZ;
        }

        renderSieve(te, x + offsetX, y + offsetY, z + offsetZ, tes, wr);
        renderBlockInSieve(te, x + offsetX, y + offsetY, z + offsetZ, tes, wr);

    }

    private void renderBlockInSieve(TileSieve te, double x, double y, double z, Tessellator tessellator, BufferBuilder worldRendererBuffer) {
        GlStateManager.func_179094_E();
        GlStateManager.func_179137_b(x, y, z);
        // GlStateManager.translate(0, 1, 0);

        if (te.getTexture() != null && te.getCurrentStack() != null) {
            TextureAtlasSprite icon = te.getTexture();
            double minU = (double) icon.func_94209_e();
            double maxU = (double) icon.func_94212_f();
            double minV = (double) icon.func_94206_g();
            double maxV = (double) icon.func_94210_h();

            this.func_147499_a(TextureMap.field_110575_b);

            worldRendererBuffer.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181710_j);
            double height = (100.0 - te.getProgress()) / 100;
            float fillAmount = (float) (0.15625 * height + 0.84375);

            worldRendererBuffer.func_181662_b(0.0625f, fillAmount, 0.0625f).func_187315_a(minU, minV).func_181663_c(0, 1, 0).func_181675_d();
            worldRendererBuffer.func_181662_b(0.0625f, fillAmount, 0.9375f).func_187315_a(minU, maxV).func_181663_c(0, 1, 0).func_181675_d();
            worldRendererBuffer.func_181662_b(0.9375f, fillAmount, 0.9375f).func_187315_a(maxU, maxV).func_181663_c(0, 1, 0).func_181675_d();
            worldRendererBuffer.func_181662_b(0.9375f, fillAmount, 0.0625f).func_187315_a(maxU, minV).func_181663_c(0, 1, 0).func_181675_d();

            tessellator.func_78381_a();
        }

        GlStateManager.func_179084_k();
        GlStateManager.func_179145_e();
        GlStateManager.func_179121_F();

    }

    private void renderSieve(TileSieve tile, double x, double y, double z, Tessellator tessellator, BufferBuilder worldRendererBuffer) {
        final BlockRendererDispatcher blockRenderer = Minecraft.func_71410_x().func_175602_ab();
        IBlockState state = tile.func_145838_q().func_176223_P().func_177226_a(BlockSieve.MESH, tile.getMeshType());
        // IBlockState state = tile.getBlockType().getDefaultState().withProperty(BlockSieve.MESH, BlockSieve.MeshType.getMeshTypeByID(tile.getMeshStack().getMetadata()));

        List<BakedQuad> quadsSieve = blockRenderer.func_184389_a(state).func_188616_a(state, null, 0);
        //TODO: possibly optimize to not call this every render, maybe HashMap for that?


        tessellator = Tessellator.func_178181_a();
        GlStateManager.func_179094_E();

        GlStateManager.func_179137_b(x, y, z);

        GlStateManager.func_179112_b(770, 771);
        GlStateManager.func_179147_l();
        GlStateManager.func_179129_p();


        RenderHelper.func_74518_a();

        Minecraft.func_71410_x().field_71446_o.func_110577_a(TextureMap.field_110575_b);

        worldRendererBuffer.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_176600_a);
        // worldRendererBuffer.setTranslation(-.5, -.5, -.5);

        RenderUtils.renderModelTESRFast(quadsSieve, worldRendererBuffer, tile.func_145831_w(), tile.func_174877_v());

        // worldRendererBuffer.setTranslation(0, 0, 0);
        tessellator.func_78381_a();

        GlStateManager.func_179121_F();
        RenderHelper.func_74519_b();

        GlStateManager.func_179084_k();
        GlStateManager.func_179089_o();
    }

}
