package exnihilocreatio.util;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.Setter;
import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.ResourceLocation;

@AllArgsConstructor
public class BlockInfo {
    @Getter
    private Block block;

    @Getter
    @Setter
    private int meta;

    public BlockInfo(IBlockState state) {
        block = state == null ? null : state.func_177230_c();
        meta = state == null ? -1 : state.func_177230_c().func_176201_c(state);
    }

    public BlockInfo(ItemStack stack) {
        block = (stack == null || stack.func_77973_b() == Items.field_190931_a || !(stack.func_77973_b() instanceof ItemBlock)) ? null : Block.func_149634_a(stack.func_77973_b());
        meta = (stack == null || stack.func_77973_b() == Items.field_190931_a) ? 0 : stack.func_77952_i();
    }

    public BlockInfo(String string) {
        String[] split = string.split(":");

        if (split.length == 1) {
            block = Block.func_149684_b("minecraft:" + split[0]);
        } else if (split.length == 2) {
            try {
                meta = split[1].equals("*") ? -1 : Integer.parseInt(split[1]);
                block = Block.func_149684_b("minecraft:" + split[0]);
            } catch (NumberFormatException e) {
                meta = -1;
                block = Block.func_149684_b(split[0] + ":" + split[1]);
            }
        } else if (split.length == 3) {
            try {
                meta = split[2].equals("*") ? -1 : Integer.parseInt(split[2]);
                block = Block.func_149684_b(split[0] + ":" + split[1]);
            } catch (NumberFormatException e) {
                meta = -1;
            }
        } else {
            meta = -1;
        }
    }

    public static BlockInfo readFromNBT(NBTTagCompound tag) {
        Block item_ = Block.field_149771_c.func_82594_a(new ResourceLocation(tag.func_74779_i("block")));
        int meta_ = tag.func_74762_e("meta");

        return new BlockInfo(item_, meta_);
    }

    public static boolean areEqual(BlockInfo block1, BlockInfo block2) {
        if (block1 == null && block2 == null)
            return true;

        return block1 != null && block2 != null && block1.equals(block2);

    }

    public String toString() {
        return Block.field_149771_c.func_177774_c(block) + (meta == -1 ? "" : (":" + meta));
    }

    public NBTTagCompound writeToNBT(NBTTagCompound tag) {
        tag.func_74778_a("block", Block.field_149771_c.func_177774_c(block).toString());
        tag.func_74768_a("meta", meta);

        return tag;
    }

    @SuppressWarnings("deprecation")
    public IBlockState getBlockState() {
        return block == null ? null : block.func_176203_a(meta == -1 ? 0 : meta);
    }

    public int hashCode() {
        return block == null ? 37 : block.hashCode();
    }

    public boolean equals(Object other) {
        if (other instanceof BlockInfo) {
            BlockInfo info = (BlockInfo) other;

            if (block == null || info.block == null) {
                return false;
            }

            if (meta == -1 || info.meta == -1) {
                return block.equals(info.block);
            } else {
                return meta == info.meta && block.equals(info.block);
            }
        }

        return false;
    }

    public ItemStack getItemStack(){
        Item item = Item.func_150898_a(block);
        return new ItemStack(item, 1, meta);
    }
}
